using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace dotNet {

  public partial class StringStackView : Form {

    private StringStackInterface document_;

    // RXgN^BDocumentp[^Ɏ󂯎
    public StringStackView(StringStackInterface doc) {
      document_ = doc;
      // OnUpdate\bh
      // UpdateAllViewsCxgEnhƂĐݒ
      document_.AddObserver(this.OnUpdate);
      InitializeComponent();
    }

    private void push__Click(object sender, EventArgs e) {
      document_.Push(string_.Text);
    }

    private void pop__Click(object sender, EventArgs e) {
      if (!document_.Empty()) {
        string_.Text = document_.Pop();
      }
    }

    private void clear__Click(object sender, EventArgs e) {
      document_.Clear();
    }

    // Document̃Cxg
    private void OnUpdate(object sender, EventArgs e) {
      stack_.Items.Clear();
      for (int index = document_.Size() - 1; index >= 0; --index) {
        stack_.Items.Add(document_.At(index));
      }
    }

  }

}