// StringStackDocument.h

#pragma once

namespace dotNet {

  public ref class StringStackDocument : StringStackInterface {
  public:
    StringStackDocument();
    virtual void            Push(System::String^ element);
    virtual System::String^ Pop();
    virtual void            Clear();
    virtual bool            Empty();
    virtual int             Size();
    virtual System::String^ At(int index);
    virtual void AddObserver(System::EventHandler^ handler);
    virtual void RemoveObserver(System::EventHandler^ handler);
  private:
    System::Collections::Generic::IList<System::String^>^ container_;
    event System::EventHandler^ handler_;
  };

}
